//  
// Einfaches Beispiel mit Ausgabe in einem Editor
// Schalter und ComboBox vereinfachen die Aktionen

import javax.swing.*;

import java.awt.Dimension;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import java.awt.*;


import java.sql.*;

// schalter
import java.awt.event.*;

public class JDBCAbfrage extends JFrame {

    JToolBar toolbar = new JToolBar();
    JButton bnSQL;
    
    JTextArea sqlEditor = new JTextArea();
    JTextArea ausgabeEditor  = new JTextArea("");
    

    public JDBCAbfrage() {
        setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
        setSize(900,600);        
        setGUI();
        setVisible(true);
    }
    
    private void setGUI() {
      this.getContentPane().setLayout( new BorderLayout() );

      sqlEditor.setFont( new Font("Arial", Font.PLAIN,28) );
      ausgabeEditor.setFont( new Font("Courier New", Font.BOLD,18)  );
      JSplitPane split = new JSplitPane(JSplitPane.VERTICAL_SPLIT,true,    new JScrollPane(sqlEditor),new JScrollPane(ausgabeEditor) );
      split.setDividerLocation(200);
      split.setDividerSize(5);
      this.getContentPane().add(split, BorderLayout.CENTER);
         
      this.getContentPane().add(toolbar, BorderLayout.NORTH);
      
      bnSQL = new JButton("Starte SQL");
      bnSQL.setFont( new Font("Arial", Font.BOLD,18)  );
      toolbar.add(bnSQL);

      bnSQL.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(ActionEvent e) {
          bnSQL_Click();
        }
      });
   
      
      
    }  // setGUI


    public void bnSQL_Click()  {   // throws Exception  {
      String dbDriver;
      String dbUrl;

      String user="sysdba";
      String passwd="1_aAz-47";   // masterkey";

      dbDriver = "org.firebirdsql.jdbc.FBDriver";
      dbUrl="jdbc:firebirdsql://localhost:3050/d:/progs/eclipse/JDBCAbfrage/EMPLOYEE.FDB";

        // Verbindung zur Datenbank, Auslese Variablen
      Connection cn = null;
      Statement  st = null;
      ResultSet  rs = null;
      
      ausgabeEditor.setText("");
      try {
        
        // Treiber INIT, Verbinden  und SQL-Statement auslsen
        // Returns the Class object associated with the class or interface with the given string name.
        // class c = Class.forName( sDbDrv );
        Class.forName( dbDriver );
        
        cn = DriverManager.getConnection( dbUrl, user, passwd );
        st = cn.createStatement();        
        
        rs = st.executeQuery(  sqlEditor.getText() );

        // Get meta data:
        ResultSetMetaData rsmd = rs.getMetaData();
        int i, AnzCols;
        AnzCols = rsmd.getColumnCount();
        // Ausgabe der Tabelle:
        // Oberste Zeile
        StringBuilder sb = new StringBuilder();
        for( i=0; i<AnzCols; i++ ) {
        	sb.append("+-----------------" );
        }
        sb.append("+\n");
        
        
        for( i=1; i<=AnzCols; i++ ) {   // Attention: first column with 1 instead of 0
        	sb.append("| ");
        	sb.append(extendStringToN( 16,rsmd.getColumnName( i ) ) );
        }
        sb.append("|\n" );
        
        for( i=0; i<AnzCols; i++ ) {
        	sb.append( "+-----------------" );
        }
        sb.append("+\n");
        
          // Schleife ber alle Tupel
        while( rs.next() ) {
          for( i=1; i<=AnzCols; i++ ) { // Attention: first column with 1 instead of 0
        	  sb.append("| ");
        	  sb.append(extendStringToN( 16,rs.getString( i ) )) ;
          }
          sb.append("|\n") ;  // Tupel-Ende
        }
        
        // Unterste Zeile
        for( i=0; i<AnzCols; i++ ) {
        	sb.append("+-----------------" );
        }
        sb.append("+\n" );
        
        ausgabeEditor.setText(sb.toString());
        
      } catch( Exception ex ) {
        System.out.println( ex );
      } finally {
        try { if( null != rs ) rs.close(); } catch( Exception ex ) {}
        try { if( null != st ) st.close(); } catch( Exception ex ) {}
        try { if( null != cn ) cn.close(); } catch( Exception ex ) {}
      }
    }     // sql


// Extend String to length of 14 characters
  private static final String extendStringToN( int iWantLen, String s )   {
    if( null == s ) s = "";
    while ( s.length() < iWantLen ) {
      s += " ";
    }
    if( s.length() > iWantLen )
        return s.substring( 0, iWantLen );
    else
        return s;
  }


    
    public static void main(String[] args) {
    	new JDBCAbfrage();
       
    }


    
}
